/*	Cory McWilliams
		mcwilc@rpi.edu
		10/2/2003 */

// Lots of useful vertex(vector) manipulation routines

#ifndef VERTEXH
#define VERTEXH

struct vertex2
{
	float x;
	float y;
};

struct vertex3
{
	float x;
	float y;
	float z;
};

typedef vertex3 vertex;

float abs(const vertex &a);
vertex normalize(const vertex &a);
vertex crossProduct(const vertex &a, const vertex &b);
float dotProduct(const vertex &a, const vertex &b);
vertex3 operator+(vertex3 const &a, vertex3 const &b);
vertex3 operator-(vertex3 const &a, vertex3 const &b);
vertex3 operator*(float a, const vertex &v);
vertex3 operator*(const vertex &v, float a);
vertex3 &operator+=(vertex3 &a, vertex3 const &b);
vertex3 operator/(vertex3 const &a, float b);
vertex3 &operator/=(vertex3 &a, float b);
vertex3 Vertex3(float x, float y, float z);

float relativeComponent(const vertex &r, const vertex &x, float absx);
float relativeVelocity(const vertex &PA, const vertex &PB, const vertex &VA, const vertex &VB);
vertex3 cubicSpline(const vertex3 &v1, const vertex3 &v2, const vertex3 &v3, const vertex3 &v4, float t);
vertex3 catmullRomSpline(const vertex3 &v1, const vertex3 &v2, const vertex3 &v3, const vertex3 &v4, float t);
void catmullRomSpline(float *points, int count, float t, float v[3]);
void catmullRomGradient(float *points, int count, float t, float v[3]);
vertex3 catmullRomGradient(const vertex3 &v1, const vertex3 &v2, const vertex3 &v3, const vertex3 &v4, float t);

#endif
